package com.plugin.example;

import com.illumon.iris.db.tables.Table;
import com.illumon.iris.db.tables.databases.Database;
import com.plugin.example.log.AvgStockPriceLoggerInterface;

import java.io.IOException;

public class QueryUtils {
    public static Table getAvgStockPriceTable(final Database db, final String date) {
        return db.t("MarketData", "Trades")
                .where("Date = `" + date + "`")
                .view("USym", "Last")
                .avgBy("USym");
    }

    public static void logAvgStockPriceTable(final Database db, final String date, final AvgStockPriceLoggerInterface avgStockPriceLogger) throws IOException {
        final Table avgStockPriceTable = getAvgStockPriceTable(db, date);
        final String[] uSyms = (String[]) avgStockPriceTable.getColumn("USym").getDirect();
        final double[] avgPrices = (double[]) avgStockPriceTable.getColumn("Last").getDirect();
        for(int i = 0; i < uSyms.length; i++) {
            avgStockPriceLogger.log(uSyms[i], avgPrices[i]);
        }
    }
}